> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a payment schedule

GET https://rest.test.zuora.com/v1/payment-schedules/{paymentScheduleKey}

Retrieves a payment schedule by payment schedule key.

**Note:**
- The Payment Schedules feature is in the **Early Adopter** phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. To manage and access this feature through the self-service interface, see [Manage Features](https://knowledgecenter.zuora.com/Zuora_Payments/Payments_Settings/Manage_Features) in the Knowledge Center.
- This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-schedules/get-payment-schedule

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `paymentScheduleKey` (string, required) — The unique ID or number of a payment schedule. For example, `8a90857b822459cd018224dcb9eb13be`, or `PS-00000007`.

### Query parameters

- `nextPendingItems` (integer, optional) — Number of next pending payment schedule items displayed in the response body.
- `lastProcessedItems` (integer, optional) — Number of the most recent processed payment schedule items dispalyed in the response body.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `accountId` (string, optional) — ID of the account that owns the payment schedule.
- `accountNumber` (string, optional) — Number of the account that owns the payment schedule.
- `billingDocument` (GetPaymentScheduleResponseBillingDocument, optional)
- `billingDocuments` (list of GetPaymentScheduleResponseBillingDocumentsItems, optional) — Container array of the multiple billing documents associated with the payment schedule.
- `createdById` (string, optional) — The ID of the user who created this payment schedule.
- `createdDate` (date, optional) — The date and time the payment schedule is created.
- `cancellationReason` (string, optional, nullable) — The reason for the cancellation of the payment schedule item.
- `cancelledById` (string, optional, nullable) — The ID of the user who canceled this payment schedule.
- `cancelledOn` (string, optional, nullable) — The date when the payment schedule was canceled.
- `cancelDate` (date, optional) — Specifies the effective date by when the payment schedule will be canceled.
- `description` (string, optional) — The description of the payment schedule.
- `id` (string, optional) — ID of the payment schedule.
- `isCustom` (boolean, optional) — Indicates if the payment schedule is a custom payment schedule.
- `items` (list of PaymentScheduleItemCommonResponse, optional) — Container for payment schedule items.
- `nextPaymentDate` (date, optional) — The date the next payment will be processed.
- `occurrences` (integer, optional) — The number of payment schedule items that are created by this payment schedule.
- `paymentOption` (list of PaymentSchedulePaymentOptionFields, optional) — Container for the paymentOption items, which describe the transactional level rules for processing payments. Currently, only the Gateway Options type is supported. `paymentOption` of the payment schedule takes precedence over `paymentOption` of the payment schedule item.
- `paymentScheduleNumber` (string, optional) — Number of the payment schedule.
- `period` (string, optional) — For recurring payment schedule only. The period of payment generation. Available values include: `Monthly`, `Weekly`, `BiWeekly`. Return `null` for custom payment schedules.
- `prepayment` (boolean, optional) — Indicates whether the payments created by the payment schedule are used as a reserved payment. This field is available only if the prepaid cash drawdown permission is enabled. See [Prepaid Cash with Drawdown](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Invoicing/JA_Advanced_Consumption_Billing/Prepaid_Cash_with_Drawdown) for more information.
- `recentPaymentDate` (date, optional) — The date the last payment was processed.
- `runHour` (integer, optional) — [0,1,2,~,22,23] At which hour in the day in the tenant’s timezone this payment will be collected. Return `0` for custom payment schedules.
- `standalone` (boolean, optional) — Indicates if the payments that the payment schedule created are standalone payments.
- `startDate` (date, optional) — The date when the first payment of this payment schedule is proccessed.
- `status` (enum, optional) — The status of the payment schedule. - Active: There is still payment schedule item to process. - Canceled: After a payment schedule is canceled by the user, the schedule is marked as `Canceled`. - Completed: After all payment schedule items are processed, the schedule is marked as `Completed`.
  - Allowed values: `Active`, `Canceled`, `Completed`
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `totalAmount` (double, optional) — The total amount that will be collected by the payment schedule.
- `totalPaymentsErrored` (integer, optional) — The number of errored payments.
- `totalPaymentsProcessed` (integer, optional) — The number of processed payments.
- `updatedById` (string, optional) — The ID of the user who last updated this payment schedule.
- `updatedDate` (date, optional) — The date and time the payment schedule is last updated.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### GetPaymentScheduleResponseBillingDocument

- `id` (string, optional) — ID of the billing document. for example, `2c9890306fb2121e016fb21a6b550041`.
- `number` (string, optional) — The number of the billing docuemnt, for example, `INV00002345`.
- `type` (string, optional) — Indicates whether the associated billing document is a debit memo or a invoice.

### GetPaymentScheduleResponseBillingDocumentsItems

- `id` (string, optional) — ID of the billing document.
- `number` (string, optional) — Number of the billing document. If the billing document is a debit memo, it contains the debit memo number. If the billing document is an invoice, it contains the invoice number.
- `type` (enum, optional) — Denotes if the billing document is of the type invoice or debit memo.
  - Allowed values: `Invoice`, `DebitMemo`

### PaymentScheduleItemCommonResponse

Container for custom fields of a Payment Schedule Item object.

- `accountId` (string, optional) — ID of the customer account that owns the payment schedule item, for example `402880e741112b310149b7343ef81234`.
- `amount` (double, optional) — The total amount of the payment schedule.
- `balance` (double, optional) — The remaining balance of payment schedule item.
- `billingDocument` (PaymentScheduleItemCommonResponseBillingDocument, optional)
- `createdById` (string, optional) — The ID of the user who created the payment schedule item.
- `createdDate` (date, optional) — The date and time when the payment schedule item was created.
- `currency` (string, optional) — The currency of the payment.
- `description` (string, optional) — The description of the payment schedule item.
- `errorMessage` (string, optional) — The error message indicating if the error is related to configuration or payment collection.
- `id` (string, optional) — ID of the payment schedule item. For example, `412880e749b72b310149b7343ef81346`.
- `number` (string, optional) — Number of the payment schedule item.
- `paymentGatewayId` (string, optional, nullable) — ID of the payment gateway of the payment schedule item.
- `paymentMethodId` (string, optional, nullable) — ID of the payment method of the payment schedule item.
- `paymentOption` (list of PaymentSchedulePaymentOptionFields, optional) — Container for the paymentOption items, which describe the transactional level rules for processing payments. Currently, only the Gateway Options type is supported. `paymentOption` of the payment schedule takes precedence over `paymentOption` of the payment schedule item.
- `paymentScheduleId` (string, optional) — ID of the payment schedule that contains the payment schedule item, for example, `ID402880e749b72b310149b7343ef80005`.
- `paymentScheduleNumber` (string, optional) — Number of the payment schedule that contains the payment schedule item, for example, `ID402880e749b72b310149b7343ef80005`.
- `psiPayments` (list of LinkedPaymentID, optional) — Container for payments linked to the payment schedule item.
- `runHour` (integer, optional) — At which hour in the day in the tenant’s timezone this payment will be collected.
- `scheduledDate` (date, optional) — The scheduled date when the payment is processed.
- `standalone` (boolean, optional) — Indicates if the payment created by the payment schedule item is a standalone payment or not.
- `status` (enum, optional) — ID of the payment method of the payment schedule item. - `Pending`: Payment schedule item is waiting for processing. - `Processed`: The payment has been collected. - `Error`: Failed to collect the payment. - `Canceled`: After a pending payment schedule item is canceled by the user, the item is marked as `Canceled`.
  - Allowed values: `Pending`, `Processed`, `Error`, `Canceled`
- `updatedById` (string, optional) — The ID of the user who updated the payment schedule item.
- `updatedDate` (date, optional) — The date and time when the payment schedule item was last updated.

### PaymentSchedulePaymentOptionFields

- `detail` (PaymentSchedulePaymentOptionFieldsDetail, optional) — The field used to pass the transactional payment data to the gateway side in the key-value format.
- `type` (string, optional) — The type of the payment option. Currently, only `GatewayOptions` is supported for specifying Gateway Options fields supported by a payment gateway.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PaymentScheduleItemCommonResponseBillingDocument

- `id` (string, optional) — ID of the billing document. for example, `2c9890306fb2121e016fb21a6b550041`.
- `number` (string, optional) — Number of the billing docuemnt, for example, `INV00002345`.
- `type` (string, optional) — Indicates whether the associated billing document is a debit memo or a invoice.

### LinkedPaymentID

- `paymentId` (string, optional) — ID of the payment.

### PaymentSchedulePaymentOptionFieldsDetail

The field used to pass the transactional payment data to the gateway side in the key-value format.

- `key` (string, optional) — The name of the field.
- `value` (string, optional) — The value of the field.

## Examples

**Response**

```json
{
  "accountId": "8a90a2fd8074995801807816dbac52a4",
  "accountNumber": "A00000002",
  "billingDocument": {
    "id": "8a90a2fd819503b50181959525e5205d",
    "number": "INV00000001",
    "type": "Invoice"
  },
  "billingDocuments": [
    {
      "id": "8a26e082802185b201976199e1991521",
      "number": "INV-001",
      "type": "Invoice"
    },
    {
      "id": "8a11e082802185b901126e34713407d2",
      "number": "INV-002",
      "type": "Invoice"
    }
  ],
  "createdById": "8a90e082802185b901802199e15902d1",
  "createdDate": "2022-07-22",
  "cancellationReason": null,
  "cancelledById": null,
  "cancelledOn": null,
  "cancelDate": "2022-07-28",
  "description": "",
  "id": "8a90857b822459cd018224dcb9eb13be",
  "isCustom": true,
  "items": [
    {
      "amount": 30,
      "billingDocument": {
        "id": "8a90a2fd819503b50181959525e5205d",
        "number": "INV00000001",
        "type": "Invoice"
      },
      "createdById": "8a90e082802185b901802199e15902d1",
      "createdDate": "2022-07-22",
      "currency": "USD",
      "description": "",
      "errorMessage": null,
      "id": "8a90857b822459cd018224dcb9ec13bf",
      "number": "1",
      "paymentGatewayId": "8a90a2fd807499580180781775c452a8",
      "paymentMethodId": "8a90a2fd8074995801807817ebed52aa",
      "paymentScheduleId": "8a90857b822459cd018224dcb9eb13be",
      "paymentScheduleNumber": "PS-00000007",
      "runHour": 23,
      "scheduledDate": "2022-07-31",
      "standalone": false,
      "status": "Pending",
      "updatedById": "8a90e082802185b901802199e15902d1",
      "updatedDate": "2022-07-22",
      "cancelledById": null,
      "cancelledOn": null,
      "paymentId": null
    },
    {
      "amount": 10,
      "billingDocument": {
        "id": "8a90a2fd819503b50181959525e5205d",
        "number": "INV00000001",
        "type": "Invoice"
      },
      "createdById": "8a90e082802185b901802199e15902d1",
      "createdDate": "2022-07-22",
      "currency": "USD",
      "description": "",
      "errorMessage": null,
      "id": "8a90a2fd822459ec018224de77a0359d",
      "number": "2",
      "paymentGatewayId": "8a90a2fd807499580180781775c452a8",
      "paymentMethodId": "8a90a2fd8074995801807817ebed52aa",
      "paymentScheduleId": "8a90857b822459cd018224dcb9eb13be",
      "paymentScheduleNumber": "PS-00000007",
      "runHour": 20,
      "scheduledDate": "2022-08-31",
      "standalone": false,
      "status": "Pending",
      "updatedById": "8a90e082802185b901802199e15902d1",
      "updatedDate": "2022-07-22",
      "cancelledById": null,
      "cancelledOn": null,
      "paymentId": null
    }
  ],
  "nextPaymentDate": "2022-07-31",
  "occurrences": 2,
  "paymentScheduleNumber": "PS-00000007",
  "period": null,
  "recentPaymentDate": null,
  "runHour": 0,
  "standalone": false,
  "startDate": "2022-07-31",
  "status": "Active",
  "success": true,
  "totalAmount": 40,
  "totalPaymentsErrored": 0,
  "totalPaymentsProcessed": 0,
  "updatedById": "8a90e082802185b901802199e15902d1",
  "updatedDate": "2022-07-22"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/payment-schedules/paymentScheduleKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```